Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2918)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2920)
@@ -2937,13 +3014,15 @@
                        temp_pf(k,j,i) = t_surf_v(l)%t(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ELSE
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%t_surf_av(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%t_surf_av(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2952,5 +3031,5 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%t_surf_av(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ENDIF
               
@@ -2959,11 +3038,13 @@
 
               IF ( av == 0 )  THEN
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = t_surf_window_h(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = t_surf_window_h(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2972,14 +3053,16 @@
                        temp_pf(k,j,i) = t_surf_window_v(l)%t(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
 
               ELSE
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%t_surf_window_av(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%t_surf_window_av(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2989,5 +3072,5 @@
                     ENDDO
 
-                 ENDDO
+                 ENDIF
 
               ENDIF
@@ -2997,11 +3080,13 @@
 
               IF ( av == 0 )  THEN
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = t_surf_green_h(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = t_surf_green_h(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -3010,14 +3095,16 @@
                        temp_pf(k,j,i) = t_surf_green_v(l)%t(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
 
               ELSE
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%t_surf_green_av(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%t_surf_green_av(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -3027,5 +3114,5 @@
                     ENDDO
 
-                 ENDDO
+                 ENDIF
 
               ENDIF
@@ -3035,11 +3122,13 @@
 
               IF ( av == 0 )  THEN
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = t_surf_10cm_h(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = t_surf_10cm_h(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -3048,14 +3137,16 @@
                        temp_pf(k,j,i) = t_surf_10cm_v(l)%t(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
 
               ELSE
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%t_surf_10cm_av(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%t_surf_10cm_av(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -3065,5 +3156,5 @@
                     ENDDO
 
-                 ENDDO
+                 ENDIF
 
               ENDIF
@@ -3073,11 +3164,13 @@
 !--           wall temperature for  iwl layer of walls and land
               IF ( av == 0 )  THEN
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = t_wall_h(iwl,m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = t_wall_h(iwl,m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -3086,13 +3179,15 @@
                        temp_pf(k,j,i) = t_wall_v(l)%t(iwl,m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ELSE
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%t_wall_av(iwl,m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%t_wall_av(iwl,m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -3101,5 +3196,5 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%t_wall_av(iwl,m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ENDIF
              
@@ -3107,11 +3202,13 @@
 !--           window temperature for iwl layer of walls and land
               IF ( av == 0 )  THEN
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = t_window_h(iwl,m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = t_window_h(iwl,m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -3120,13 +3217,15 @@
                        temp_pf(k,j,i) = t_window_v(l)%t(iwl,m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ELSE
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%t_window_av(iwl,m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%t_window_av(iwl,m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -3135,5 +3234,5 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%t_window_av(iwl,m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ENDIF
 
@@ -3141,11 +3240,13 @@
 !--           green temperature for  iwl layer of walls and land
               IF ( av == 0 )  THEN
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = t_green_h(iwl,m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = t_green_h(iwl,m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -3154,13 +3255,15 @@
                        temp_pf(k,j,i) = t_green_v(l)%t(iwl,m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ELSE
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%t_green_av(iwl,m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%t_green_av(iwl,m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -3169,5 +3272,5 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%t_green_av(iwl,m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ENDIF
 
@@ -3180,7 +3283,9 @@
 !
 !--     Rearrange dimensions for NetCDF output
+!--     FIXME: this may generate FPE overflow upon conversion from DP to SP
         DO  j = nys, nyn
             DO  i = nxl, nxr
                 DO  k = nzb_do, nzt_do
+!                   print*, j,nys,nyn,i,nxl,nxr,k,nzb_do,nzt_do,local_pf(i,j,k),temp_pf(k,j,i)
                     local_pf(i,j,k) = temp_pf(k,j,i)
                 ENDDO
@@ -3228,5 +3333,6 @@
              var(1:7) == 'usm_dif'  .OR.  var(1:11) == 'usm_surfcat'  .OR.                  &
              var(1:11) == 'usm_surfalb'  .OR.  var(1:12) == 'usm_surfemis'  .OR.            &
-             var(1:16) == 'usm_surfwintrans' )  THEN
+             var(1:16) == 'usm_surfwintrans'  .OR.                                          &
+             var(1:9) == 'usm_skyvf' .OR. var(1:9) == 'usm_skyvft' ) THEN
 
             found = .TRUE.
@@ -3416,7 +3522,8 @@
         INTEGER(iwp) ::  st                  !< dummy  
 
-        REAL(wp)     ::  c, d, tin, twin, exn
+        REAL(wp)     ::  c, d, tin, twin
         REAL(wp)     ::  ground_floor_level_l         !< local height of ground floor level
         REAL(wp)     ::  z_agl                        !< height above ground
+        REAL(wp), DIMENSION(nzb:nzt)   ::  exn        !< value of the Exner function in layers
 
 !
@@ -4402,5 +4509,5 @@
             CALL usm_read_anthropogenic_heat()
         ENDIF
-                
+
         IF ( plant_canopy )  THEN
             
@@ -4419,5 +4526,7 @@
        
 !--         Calculate initial surface temperature from pt of adjacent gridbox
-            exn = ( surface_pressure / 1000.0_wp )**0.286_wp
+#if ! defined( __nopointer )
+            exn(nzb:nzt) = (hyp(nzb:nzt) / 100000.0_wp )**0.286_wp          !< Exner function
+#endif
 
 !
@@ -4430,8 +4539,8 @@
                k = surf_usm_h%k(m)
 
-               t_surf_h(m) = pt(k,j,i) * exn
-               t_surf_window_h(m) = pt(k,j,i) * exn
-               t_surf_green_h(m) = pt(k,j,i) * exn
-               surf_usm_h%pt_surface(m) = pt(k,j,i) * exn
+               t_surf_h(m) = pt(k,j,i) * exn(k)
+               t_surf_window_h(m) = pt(k,j,i) * exn(k)
+               t_surf_green_h(m) = pt(k,j,i) * exn(k)
+               surf_usm_h%pt_surface(m) = pt(k,j,i) * exn(k)
             ENDDO
 !
@@ -4443,8 +4552,8 @@
                   k = surf_usm_v(l)%k(m)
 
-                  t_surf_v(l)%t(m) = pt(k,j,i) * exn
-                  t_surf_window_v(l)%t(m) = pt(k,j,i) * exn
-                  t_surf_green_v(l)%t(m) = pt(k,j,i) * exn
-                  surf_usm_v(l)%pt_surface(m) = pt(k,j,i) * exn
+                  t_surf_v(l)%t(m) = pt(k,j,i) * exn(k)
+                  t_surf_window_v(l)%t(m) = pt(k,j,i) * exn(k)
+                  t_surf_green_v(l)%t(m) = pt(k,j,i) * exn(k)
+                  surf_usm_v(l)%pt_surface(m) = pt(k,j,i) * exn(k)
                ENDDO
             ENDDO
@@ -4496,5 +4605,8 @@
                ENDDO
             ENDDO
-
+        ELSE
+!--         If specified, replace constant wall temperatures with fully 3D values from file
+            IF ( read_wall_temp_3d )  CALL usm_read_wall_temperature()
+!
         ENDIF
         
@@ -4519,4 +4631,9 @@
         t_green_h_p = t_green_h
         t_green_v_p = t_green_v
+
+!--     Adjust radiative fluxes for urban surface at model start
+        !CALL radiation_interaction
+!--     TODO: interaction should be called once before first output,
+!--     that is not yet possible.
         
         CALL cpu_log( log_point_s(78), 'usm_init', 'stop' )
@@ -5029,15 +5146,18 @@
                            building_type,                                      &
                            land_category,                                      &
-                           pedestrant_category,                                &
-                           ra_horiz_coef,                                      &
+                           naheatlayers,                                       &
+                           pedestrian_category,                                &
+                           roughness_concrete,                                 &
+                           read_wall_temp_3d,                                  &
                            roof_category,                                      &
                            urban_surface,                                      &
                            usm_anthropogenic_heat,                             &
                            usm_material_model,                                 &
-                           usm_lad_rma,                                        &
                            wall_category,                                      &
-                           indoor_model
-
-       line = ' '
+                           indoor_model,                                       &
+                           wall_inner_temperature,                             &
+                           roof_inner_temperature,                             &
+                           soil_inner_temperature,                             &
+                           window_inner_temperature
 
 !
@@ -5134,10 +5254,10 @@
     SUBROUTINE usm_read_anthropogenic_heat
     
-        INTEGER(iwp)                  :: i,j,ii
+        INTEGER(iwp)                  :: i,j,k,ii
         REAL(wp)                      :: heat
-        
+
 !--     allocation of array of sources of anthropogenic heat and their diural profile
-        ALLOCATE( aheat(nys:nyn,nxl:nxr) )
-        ALLOCATE( aheatprof(0:24) )
+        ALLOCATE( aheat(naheatlayers,nys:nyn,nxl:nxr) )
+        ALLOCATE( aheatprof(naheatlayers,0:24) )
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -5154,8 +5274,10 @@
                 j = 0
                 DO
-                    READ( 151, *, err=12, end=13 )  i, j, heat
+                    READ( 151, *, err=12, end=13 )  i, j, k, heat
                     IF ( i >= nxl  .AND.  i <= nxr  .AND.  j >= nys  .AND.  j <= nyn )  THEN
-!--                     write heat into the array
-                        aheat(j,i) = heat
+                        IF ( k <= naheatlayers  .AND.  k > get_topography_top_index_ji( j, i, 's' ) )  THEN
+!--                         write heat into the array
+                            aheat(k,j,i) = heat
+                        ENDIF
                     ENDIF
                     CYCLE
@@ -5186,8 +5308,8 @@
                 i = 0
                 DO
-                    READ( 151, *, err=22, end=23 )  i, heat
-                    IF ( i >= 0  .AND.  i <= 24 )  THEN
+                    READ( 151, *, err=22, end=23 )  i, k, heat
+                    IF ( i >= 0  .AND.  i <= 24  .AND.  k <= naheatlayers )  THEN
 !--                     write heat into the array
-                        aheatprof(i) = heat
+                        aheatprof(k,i) = heat
                     ENDIF
                     CYCLE
@@ -5196,5 +5318,5 @@
                     CALL message( 'usm_read_anthropogenic_heat', 'PA0517', 0, 1, 0, 6, 0 )
                 ENDDO
-                aheatprof(24) = aheatprof(0)
+                aheatprof(:,24) = aheatprof(:,0)
  23             CLOSE(151)
                 CYCLE
@@ -5212,13 +5334,7 @@
 
 !------------------------------------------------------------------------------!
-!
 ! Description:
 ! ------------
-!> Soubroutine reads t_surf and t_wall data from restart file(s)
-!kanani: Renamed this routine according to corresponging routines in PALM
-!kanani: Modified the routine to match rrd_global, from where usm_rrd_local
-!        shall be called in the future. This part has not been tested yet. (see virtual_flight_mod)
-!        Also, I had some trouble with the allocation of t_surf, since this is a pointer.
-!        So, I added some directives here.
+!> Soubroutine reads t_surf and t_wall data from restart files
 !------------------------------------------------------------------------------!
     SUBROUTINE usm_rrd_local( i, k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,       &
@@ -6623,4 +6739,6 @@
               surf_usm_h%albedo(:,m) = surface_params(ialbedo,ip)
            ENDIF
+!--        Albedo type is 0 (custom), others are replaced later
+           surf_usm_h%albedo_type(:,m) = 0
 !--        Transmissivity
            IF ( surf_usm_h%transmissivity(m) < 0.0_wp )  THEN
@@ -6636,7 +6754,9 @@
            surf_usm_h%lambda_surf_green(m)  = surface_params(ilambdas,ip)
 !            
-!--        roughness relative to concrete
+!--        roughness length for momentum, heat and humidity
            surf_usm_h%z0(m) = surface_params(irough,ip)
-!            
+           surf_usm_h%z0h(m) = surface_params(iroughh,ip)
+           surf_usm_h%z0q(m) = surface_params(iroughh,ip)
+!
 !--        Surface skin layer heat capacity (J mâ2 Kâ1 )
            surf_usm_h%c_surface(m) = surface_params(icsurf,ip)
@@ -6676,5 +6796,5 @@
               j  = surf_usm_v(l)%j(m)
               kw = surf_usm_v(l)%k(m)
-
+              
               IF ( l == 3 )  THEN ! westward facing
                  iw = i
@@ -6699,8 +6819,17 @@
               ENDIF
 
-              IF ( kw <= usm_par(ii,jw,iw) )  THEN
-!--              pedestrant zone
+              IF ( iw < 0 .OR. jw < 0 ) THEN
+!--              wall on west or south border of the domain - assign default category
+                 IF ( kw <= roof_height_limit ) THEN
+                     surf_usm_v(l)%surface_types(m) = wall_category   !< default category for wall surface in wall zone
+                 ELSE
+                     surf_usm_v(l)%surface_types(m) = roof_category   !< default category for wall surface in roof zone
+                 END IF
+                 surf_usm_v(l)%albedo(:,m)    = -1.0_wp
+                 surf_usm_v(l)%thickness_wall(m) = -1.0_wp
+              ELSE IF ( kw <= usm_par(ii,jw,iw) )  THEN
+!--                 pedestrian zone
                  IF ( usm_par(ii+1,jw,iw) == 0 )  THEN
-                     surf_usm_v(l)%surface_types(m)  = pedestrant_category   !< default category for wall surface in pedestrant zone
+                     surf_usm_v(l)%surface_types(m)  = pedestrian_category   !< default category for wall surface in pedestrian zone
                      surf_usm_v(l)%albedo(:,m)    = -1.0_wp
                      surf_usm_v(l)%thickness_wall(m) = -1.0_wp
@@ -6751,8 +6880,14 @@
                  ENDIF
               ELSE
-!--              something wrong
-                 CALL message( 'usm_read_urban_surface', 'PA0505', 1, 2, 0, 6, 0 )
+!
+!--              supply the default category
+                 IF ( kw <= roof_height_limit ) THEN
+                     surf_usm_v(l)%surface_types(m) = wall_category   !< default category for wall surface in wall zone
+                 ELSE
+                     surf_usm_v(l)%surface_types(m) = roof_category   !< default category for wall surface in roof zone
+                 END IF
+                 surf_usm_v(l)%albedo(:,m)    = -1.0_wp
+                 surf_usm_v(l)%thickness_wall(m) = -1.0_wp
               ENDIF
-
 !
 !--           Find the type position
@@ -6767,7 +6902,7 @@
               IF ( ip == -99999 )  THEN
 !--              wall category not found
-                 WRITE (message_string, "(A,I5,A,3I5)") 'wall category ', it,  &
+                 WRITE (message_string, "(A,I7,A,3I5)") 'wall category ', it,  &
                                         ' not found  for i,j,k=', iw,jw,kw
-                 CALL message( 'usm_read_urban_surface', 'PA0506', 1, 2, 0, 6, 0 )
+                 WRITE(9,*) message_string
               ENDIF
 !
@@ -6776,4 +6911,6 @@
                  surf_usm_v(l)%albedo(:,m) = surface_params(ialbedo,ip)
               ENDIF
+!--           Albedo type is 0 (custom), others are replaced later
+              surf_usm_v(l)%albedo_type(:,m) = 0
 !--           Transmissivity of the windows
               IF ( surf_usm_v(l)%transmissivity(m) < 0.0_wp )  THEN
@@ -6784,13 +6921,15 @@
               surf_usm_v(l)%emissivity(:,m) = surface_params(iemiss,ip)
 !            
-!--           heat conductivity Î»S between air and wall ( W mâ2 Kâ1 )
+!--           heat conductivity lambda S between air and wall ( W m-2 K-1 )
               surf_usm_v(l)%lambda_surf(m) = surface_params(ilambdas,ip)
               surf_usm_v(l)%lambda_surf_window(m) = surface_params(ilambdas,ip)
               surf_usm_v(l)%lambda_surf_green(m) = surface_params(ilambdas,ip)
 !            
-!--           roughness relative to concrete
+!--           roughness length
               surf_usm_v(l)%z0(m) = surface_params(irough,ip)
+              surf_usm_v(l)%z0h(m) = surface_params(iroughh,ip)
+              surf_usm_v(l)%z0q(m) = surface_params(iroughh,ip)
 !            
-!--           Surface skin layer heat capacity (J mâ2 Kâ1 )
+!--           Surface skin layer heat capacity (J m-2 K-1 )
               surf_usm_v(l)%c_surface(m) = surface_params(icsurf,ip)
               surf_usm_v(l)%c_surface_window(m) = surface_params(icsurf,ip)
@@ -6809,11 +6948,11 @@
                    surf_usm_v(l)%thickness_green(m) = surface_params(ithick,ip)
               ENDIF
-!            
-!--           volumetric heat capacity rho*C of the wall ( J mâ3 Kâ1 )
+!
+!--           volumetric heat capacity rho*C of the wall ( J m-3 K-1 )
               surf_usm_v(l)%rho_c_wall(:,m) = surface_params(irhoC,ip)
               surf_usm_v(l)%rho_c_window(:,m) = surface_params(irhoC,ip)
               surf_usm_v(l)%rho_c_green(:,m) = surface_params(irhoC,ip)
 !            
-!--           thermal conductivity Î»H of the wall (W mâ1 Kâ1 )
+!--           thermal conductivity lambda H of the wall (W m-1 K-1 )
               surf_usm_v(l)%lambda_h(:,m) = surface_params(ilambdah,ip)
               surf_usm_v(l)%lambda_h_window(:,m) = surface_params(ilambdah,ip)
@@ -6848,4 +6987,108 @@
    
     END SUBROUTINE usm_read_urban_surface_types
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!
+!> This function advances through the list of local surfaces to find given
+!> x, y, d, z coordinates
+!------------------------------------------------------------------------------!
+    PURE FUNCTION advance_surface(isurfl_start, isurfl_stop, x, y, z, d) &
+            result(isurfl)
+
+        INTEGER(iwp), INTENT(in)                :: isurfl_start, isurfl_stop
+        INTEGER(iwp), INTENT(in)                :: x, y, z, d
+        INTEGER(iwp)                            :: isx, isy, isz, isd
+        INTEGER(iwp)                            :: isurfl
+
+        DO isurfl = isurfl_start, isurfl_stop
+            isx = surfl(ix, isurfl)
+            isy = surfl(iy, isurfl)
+            isz = surfl(iz, isurfl)
+            isd = surfl(id, isurfl)
+            IF ( isx==x .and. isy==y .and. isz==z .and. isd==d )  RETURN
+        ENDDO
+
+!--     coordinate not found
+        isurfl = -1
+
+    END FUNCTION
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!
+!> This subroutine reads temperatures of respective material layers in walls,
+!> roofs and ground from input files. Data in the input file must be in
+!> standard order, i.e. horizontal surfaces first ordered by x, y and then
+!> vertical surfaces ordered by x, y, direction, z
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_read_wall_temperature
+
+        INTEGER(iwp)                                          :: i, j, k, d, ii, iline
+        INTEGER(iwp)                                          :: isurfl
+        REAL(wp)                                              :: rtsurf
+        REAL(wp), DIMENSION(nzb_wall:nzt_wall+1)              :: rtwall
+
+
+
+
+        DO  ii = 0, io_blocks-1
+            IF ( ii == io_group )  THEN
+
+!--             open wall temperature file
+                OPEN( 152, file='WALL_TEMPERATURE'//coupling_char, action='read', &
+                           status='old', form='formatted', err=15 )
+
+                isurfl = 0
+                iline = 1
+                DO
+                    rtwall = -9999.0_wp  !< for incomplete lines
+                    READ( 152, *, err=13, end=14 )  i, j, k, d, rtsurf, rtwall
+
+                    IF ( nxl <= i .and. i <= nxr .and. &
+                        nys <= j .and. j <= nyn)  THEN  !< local processor
+!--                     identify surface id
+                        isurfl = advance_surface(isurfl+1, nsurfl, i, j, k, d)
+                        IF ( isurfl == -1 )  THEN
+                            WRITE(message_string, '(a,4i5,a,i5,a)') 'Coordinates (xyzd) ', i, j, k, d, &
+                                ' on line ', iline, &
+                                ' in file WALL_TEMPERATURE are either not present or out of standard order of surfaces.'
+                            CALL message( 'usm_read_wall_temperature', 'PA0521', 1, 2, 0, 6, 0 )
+                        ENDIF
+
+!--                     assign temperatures
+                        IF ( d == 0 ) THEN
+                           t_surf_h(isurfl) = rtsurf
+                           t_wall_h(:,isurfl) = rtwall(:)
+                        ELSE
+                           t_surf_v(d-1)%t(isurfl) = rtsurf
+                           t_wall_v(d-1)%t(:,isurfl) = rtwall(:)
+                        ENDIF
+                    ENDIF
+
+                    iline = iline + 1
+                    CYCLE
+ 13                 WRITE(message_string, '(a,i5,a)') 'Error reading line ', iline, &
+                        ' in file WALL_TEMPERATURE.'
+                    CALL message( 'usm_read_wall_temperature', 'PA0522', 1, 2, 0, 6, 0 )
+                ENDDO
+ 14             CLOSE(152)
+                CYCLE
+ 15             message_string = 'file WALL_TEMPERATURE'//TRIM(coupling_char)//' does not exist'
+                CALL message( 'usm_read_wall_temperature', 'PA0523', 1, 2, 0, 6, 0 )
+            ENDIF
+#if defined( __parallel ) && ! defined ( __check )
+            CALL MPI_BARRIER( comm2d, ierr )
+#endif
+        ENDDO
+
+        CALL location_message( '    wall layer temperatures read', .TRUE. )
+
+    END SUBROUTINE usm_read_wall_temperature
+
 
 
